export default function startMove(obj, json, times, fx, fn) {
    console.log('aaa')
    let iCur = {}
    for (let attr in json) {
        iCur[attr] = 0

        if (attr == 'opacity') {
            iCur[attr] = Math.round(getStyle(obj, attr) * 100)
        } else {
            iCur[attr] = parseInt(getStyle(obj, attr))
        }
    }

    let startTime = now()

    /* 定时器*/
    clearInterval(obj.timer)

    obj.timer = setInterval(function() {
        let changeTime = now()

        let currentTime = times - Math.max(0, startTime - changeTime + times)
        // 0 到 2000
      
        for (let attr in json) {
            let value = Tween[fx](currentTime, iCur[attr], json[attr] - iCur[attr], times)

            if (attr == 'opacity') {
                obj.style.opacity = value / 100
                obj.style.filter = `alpha(opacity = ${value})`
            } else {
                obj.style[attr] = `${value}px`
            }
        }

        if (currentTime == times) {
            clearInterval(obj.timer)
            if (fn) {
                fn.call(obj)
            }
        }
    }, 13)

    function getStyle(obj, attr) {
        if (obj.currentStyle) {
            return obj.currentStyle[attr]
        } else {
            return getComputedStyle(obj, false)[attr]
        }
    }

    function now() {
        return (new Date()).getTime()
    }
}

let Tween = {
    // 匀速
    linear (currentTime, beginingTime, changValue, duration) {  
        //  currentTime/duration = prop;
        return ((changValue * currentTime) / duration) + beginingTime  
    },
    // 加速曲线
    easeIn(currentTime, beginingTime, changValue, duration) {  
        return (changValue * (currentTime /= duration) * currentTime) + beginingTime
    },
    // 减速曲线
    easeOut(currentTime, beginingTime, changValue, duration) {  
        return (-changValue * (currentTime /= duration) * (currentTime - 2)) + beginingTime
    }
}